#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    long long n,q;
    cin>>n>>q;
    vector<long long> niz(n+1);
    vector<long long> nule;
    bool jeste=true;
    for(long long i=1;i<=n;i++){
        cin>>niz[i];
        if(niz[i]==0){
            nule.push_back(i);
        }
        if(niz[i]!=1 && niz[i]!=0) jeste=false;
    }
    sort(nule.begin(),nule.end());
    while(q--){
        long long l,r;
        cin>>l>>r;
        if(jeste){
            auto nes=lower_bound(nule.begin(),nule.end(),l);
            if(nule.size()==0){
                cout<<1<<endl;
                continue;
            }
            if(nes==nule.end()){
                cout<<1<<endl;
                continue;
            }
            long long prva=*nes;
    //        cout<<prva<<" ";
        //    cout<<prva<<" "<<druga<<" ";
            if(prva>r){
                cout<<1<<endl;
            }else{
                cout<<0<<endl;
            }
        }else{
            long long rez=niz[l];
            for(long long i=l+1;i<=r;i++){
       //         cout<<rez<<endl;
                rez&=niz[i];
            }
            cout<<rez<<endl;
        }
    }
    return 0;
}